
#include <color.hpp>
#include <algorithm>


#include <sstream>
#include <cmath>

namespace cpe
{
  color::color()
  {r=0;g=0;b=0;}

  color::color(octet r_local,octet g_local,octet b_local)
      :r(r_local),g(g_local),b(b_local)
  {}

  color::color(int r_local,int g_local,int b_local)
  {
    r=static_cast<unsigned char>(std::min(std::max(r_local,0),255));
    g=static_cast<unsigned char>(std::min(std::max(g_local,0),255));
    b=static_cast<unsigned char>(std::min(std::max(b_local,0),255));
  }

  std::string color::to_string() const
  {
      std::stringstream str;
      str<<static_cast<int>(r)<<" "
         <<static_cast<int>(g)<<" "
         <<static_cast<int>(b);
      return str.str();
  }

  std::ostream& operator<<(std::ostream& stream,const color& c)
  {
      stream<<c.to_string();
      return stream;
  }

  int color::red() const {return r;}
  int color::green() const {return g;}
  int color::blue() const {return b;}

  octet& color::red() {return r;}
  octet& color::green() {return g;}
  octet& color::blue() {return b;}

  double color::norm(const color& c1,const color& c2)
  {
      double d_red=static_cast<double>(c1.red())-static_cast<double>(c2.red());
      double d_green=static_cast<double>(c1.green())-static_cast<double>(c2.green());
      double d_blue=static_cast<double>(c1.blue())-static_cast<double>(c2.blue());

      double n=std::sqrt(d_red*d_red+d_green*d_green+d_blue*d_blue);
      return n;
  }
  
}
