
/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 */

#ifndef IO_EXCEPTION_HPP
#define IO_EXCEPTION_HPP

#include <string>


namespace cpe
{


/** \brief Class of exception to handle errors of Input/Output */
class io_exception
{
public:

    /** \brief empty constructor */
    io_exception();
    /** \brief constructor with error information */
    io_exception(const std::string& msg,const std::string& file,const std::string& caller,const int& line);
    
    /** \brief return error message */
    std::string info() const;

private:

    /** \brief error message storage */
    std::string message;
    /** \brief caller name storage */
    std::string caller;
    /** \brief file name storage */
    std::string file;
    /** \brief error line storage */
    std::string line;

};

}


#endif
