
/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 */

#ifndef IO_JPEG_HPP
#define IO_JPEG_HPP

#include <image.hpp>
#include <io_image.hpp>

namespace cpe
{

/** Input/Output class for jpeg reading/writing */
class io_jpeg : public io_image
{
public:

    // ********************************************* //
    // ********************************************* //
    //  Interface
    // ********************************************* //
    // ********************************************* //

    /** \brief Read jpeg image */
    virtual image read(const std::string& filename) const;
    /** \brief Write jpeg image */
    virtual void write(const image& im,const std::string& filename) const;

private:
};
}

#endif
