
/**
 * **************************************************
 * **************************************************
 *   _____ _____  ______   _
 *  / ____|  __ \|  ____| | |
 * | |    | |__) | |__    | |    _   _  ___  _ __
 * | |    |  ___/|  __|   | |   | | | |/ _ \| '_ \
 * | |____| |    | |____  | |___| |_| | (_) | | | |
 *  \_____|_|    |______| |______\__, |\___/|_| |_|
 *                                __/ |
 *                               |___/
 * **************************************************
 * **************************************************
 *
 */

#ifndef IO_IMAGE_HPP
#define IO_IMAGE_HPP

#include <string>

namespace cpe
{
class image;

/** Input/Output class for image manipulation
 *  Generic class with read/write interface needed to be specialised in specific format
 */
class io_image
{
public:

    // ********************************************* //
    // ********************************************* //
    //  Interface
    // ********************************************* //
    // ********************************************* //

    /** \brief Read interface: Read a file and return an image */
    virtual image read(const std::string& filename) const=0;

    /** \brief Write interface: Write an image into the pointed file */
    virtual void write(const image& im,const std::string& filename) const=0;


    // ********************************************* //
    // ********************************************* //
    //  Constructor/destructor
    // ********************************************* //
    // ********************************************* //

    /** \brief virtual destructor */
    virtual ~io_image();


private:
};


}

#endif
