
#include <io_png.hpp>
#include <io_jpeg.hpp>
#include <io_exception.hpp>
#include <image.hpp>
#include <color.hpp>


#include <iostream>

using namespace cpe;

int main()
{
    try
    {
        //declaration structure i/o en png
        cpe::io_png handle_png;
        //lecture de l'image
        cpe::image image_1=handle_png.read("../data/im_00.png");

        //remplissage par bloc d'une couleur uniforme
        image_1.fill_bloc(20,20,16,color(255,255,0));

        //modification de couleur pixel a pixel
        for(unsigned int k=0;k<60;++k)
        {
            image_1(150+k,100+k)=color(255,0,0);
            image_1(151+k,100+k)=color(0,0,255);
            image_1(152+k,100+k)=color(0,255,0);
        }

        //creation d'une nouvelle image blanche
        cpe::image image_2(image_1.Nx(),image_1.Ny());image_2.fill(color(255,255,255));

        //copie par bloc de l'image_1 vers l'image_2 sur une nouvelle destination
        cpe::image::copy_bloc(248,140,image_1,150,150,&image_2,32);
        //copie du meme bloc sur d'autres coordonnees
        cpe::image::copy_bloc(248,140,image_1,190,150,&image_2,32);

        //ecriture des images sur le disque
        handle_png.write(image_1,"test_01.png");
        handle_png.write(image_2,"test_02.png");
    }
    //recuperation des exceptions
    catch(cpe::io_exception e)
    {
        std::cout<<e.info()<<std::endl;
    }
    return 0;
}
